import java.awt.*;
import java.awt.event.*;
import de.kawt.*;


public class LottoCalc extends KAWTlet implements ActionListener {

    private Frame frame = new Frame ();
    Label label;
    TextField input;
    Button action, clear;
    Button numKey[];
    Label result;
    
    public LottoCalc () {
        MenuBar menuBar = new MenuBar ();
        Menu menu = new Menu ("Info");
        MenuItem mi = new MenuItem ("About Lotto");
        mi.addActionListener (this);
        menu.add (mi);

        mi = new MenuItem ("Memory");
        mi.addActionListener (this);
        menu.add (mi);
	
	    mi = new MenuItem ("Exit");
        mi.addActionListener (this);
        menu.add (mi);
	   
	    menuBar.add (menu);
	    
        frame.setMenuBar (menuBar);
        
        Panel containPanel = new Panel(new FlowLayout());
        
        label = new Label("How many numbers do u want to buy?");
        containPanel.add(label);
        
        input = new TextField(14);
        containPanel.add(input);
        
        action = new Button("Calculate");
        action.addActionListener(this);
        containPanel.add(action);
        
        numKey = new Button[10];
        for (int i = 0 ; i < numKey.length; i++) {
            numKey[i] = new Button(i + "");
            numKey[i].addActionListener (this);
            containPanel.add(numKey[i]);
        }
        clear = new Button("Clear");
        clear.addActionListener (this);
        containPanel.add(clear);
        result = new Label("                                                                  ");
        containPanel.add(result);
        
        frame.add(containPanel);
	    frame.addWindowListener (new Closer (this));

        frame.pack ();
    }

    private long factorial( long numberL ) {                  
      // base case
        long result = 1;
        for (long i=2; i<=numberL; i++)
            result *= i;
        return result;

    }  // end method factorial
    
    public void startApp () {
	    frame.show ();
    }


    public void destroyApp (boolean uncond) {
	    frame.dispose ();
    }
    
    
    public void actionPerformed (ActionEvent e) {
	  String cmd = e.getActionCommand ();
	  if (cmd.equals ("About Lotto")) {
	      OptionDialog.showMessageDialog 
		  (frame, "For information about Lotto, please visit\nhttp://www.Lotto.com");
	  } else if (cmd.equals ("Memory")) {
   	      int count = 0;
	      long free0 = Runtime.getRuntime().freeMemory ();
	      long free = free0;
	      while (true) {
		    Runtime.getRuntime().gc();
		    long newFree = Runtime.getRuntime().freeMemory ();
		    if (newFree <= free) break;
		    count ++;
		    free = newFree;
	      }
	      OptionDialog.showMessageDialog (frame, "ini: "+free0+"\ngc"+count+": "+free);
	  } else  if (cmd.equals ("Exit")) {
            destroyApp (true);
            new Lotto ().startApp ();
            notifyDestroyed ();
	  } else  if (cmd.equals ("0")) {
            input.setText(input.getText() + "0");
	  } else  if (cmd.equals ("1")) {
            input.setText(input.getText() + "1");
	  } else  if (cmd.equals ("2")) {
            input.setText(input.getText() + "2");
	  } else  if (cmd.equals ("3")) {
            input.setText(input.getText() + "3");
	  } else  if (cmd.equals ("4")) {
            input.setText(input.getText() + "4");
	  } else  if (cmd.equals ("5")) {
            input.setText(input.getText() + "5");
	  } else  if (cmd.equals ("6")) {
            input.setText(input.getText() + "6");
	  } else  if (cmd.equals ("7")) {
            input.setText(input.getText() + "7");
	  } else  if (cmd.equals ("8")) {
            input.setText(input.getText() + "8");
	  } else  if (cmd.equals ("9")) {
            input.setText(input.getText() + "9");
	  } else  if (cmd.equals ("Clear")) {
            input.setText("");
	  } else  if (cmd.equals ("Calculate")) {
            if(input.getText().equals(""))
               return;
            int number = Integer.parseInt(input.getText(),10);
            if (number < 6 || number > 42) {
               input.setText("");
               result.setText("illegal");
               return;
            }
            long cost = 50 * C(number, 6);
            result.setText("Total Cost : $" + cost);
	  }
    
    }

    public static void main (String [] argv) {
        new LottoCalc ().startApp ();
    }

    private static long NewFactor(int start, int end) // ΨӺsn
    {
        long result = (long) start;
        
        for (int i=start+1; i<=end; i++)
            result *= i;

        return result;
    }

    private static long C(int n, int m) // զX
    {
        if (n == m)
            return 1;
        else
            return NewFactor((n - m > m) ? (n - m + 1) : (m + 1), n) / (NewFactor(1, (n - m > m) ? (m) : (n - m)));
    }
    
}